#!/bin/bash

PID=$(pgrep gammastep)
RUNNING=`cat $HOME/.spool/gammastep.status`

ACTION=$1
if [[ "$1" == '' ]]; then
        ACTION='bar'
fi
echo "$ACTION" >&2

if [[ $ACTION == 'bar' ]]; then
        :
elif [[ $ACTION == 'toggle' ]]; then
        if [ "$PID" ]; then
                kill -SIGUSR1 $PID
        else
                echo 'Gammastep is not running'
        fi
elif [[ $ACTION == 'start' ]]; then
        if [ "$PID" ]; then
                echo 'Gammastep is already running'
        else
                $HOME/scripts/sway/gammastep.pl
        fi
elif [[ $ACTION == 'stop' ]]; then
        if [ "$PID" ]; then
                kill $PID
        else
                echo 'Gammastep is not running'
        fi
elif [[ $ACTION == 'enable' ]]; then
        if [ $PID ]; then
                if [ $RUNNING ]; then
                        echo 'Already enabled'
                else
                        kill -SIGUSR1 $PID
                fi
        else
                echo 'Gammastep is not running'
        fi
elif [[ $ACTION == 'disable' ]]; then
        if [ $PID ]; then
                if [ $RUNNING ]; then
                        kill -SIGUSR1 $PID
                else
                        echo 'Already disabled'
                fi
        else
                echo 'Gammastep in not running'
        fi
else
        echo "Invalid argument '$ACTION'. Use 'bar', 'toggle', 'start', 'stop', 'enable', 'disable'."
fi

RUNNING=`cat $HOME/.spool/gammastep.status`
if [ "$RUNNING" ]; then
        echo '{"text":"ɣ","icon":"ɣ","tooltip":"Disable Gammastep","class":"enabled"}'
else
        echo '{"text":"ɣ","icon":"ɣ","tooltip":"Enable Gammastep","class":"disabled"}'
fi
